package com.book.push.handler;

import com.book.dao.cps.pojo.AdminConfig;
import com.book.dao.cps.pojo.SignRecommand;
import com.book.dao.cps.pojo.User;
import com.book.push.service.dao.AdminConfigService;
import com.book.push.service.dao.PlatformService;
import com.book.push.service.dao.SignRecommendService;
import com.book.push.service.dao.UserService;
import com.book.push.service.push.PushService;
import com.book.push.service.wx.WxThirdPartService;
import me.chanjar.weixin.common.session.WxSessionManager;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import me.chanjar.weixin.mp.builder.kefu.NewsBuilder;
import me.chanjar.weixin.open.api.WxOpenMpService;
import me.chanjar.weixin.open.api.WxOpenService;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

import static me.chanjar.weixin.common.api.WxConsts.EventType;

/**
 * @author 点击菜单事件
 */
@Component
public class MenuHandler extends AbstractHandler {
    @Autowired
    private PushService pushService;
    @Autowired
    private UserService userService;
    @Autowired
    private AdminConfigService adminConfigService;
    @Autowired
    private PlatformService platformService;
    @Autowired
    private WxThirdPartService wxThirdPartService;
    @Autowired
    private SignRecommendService signRecommendService;

    @Override
    public WxMpXmlOutMessage handle(WxMpXmlMessage wxMessage,
                                    Map<String, Object> context, WxMpService weixinService,
                                    WxSessionManager sessionManager) {
        String msg = String.format("type:%s, event:%s, key:%s",
                wxMessage.getMsgType(), wxMessage.getEvent(),
                wxMessage.getEventKey());
        if (EventType.VIEW.equals(wxMessage.getEvent())) {
            return null;
        }

        String openid = wxMessage.getFromUser();
        AdminConfig adminConfig = userService.selectAdminConfigByOpenid(openid);
        Integer platformId = adminConfig.getPlatformId();
        WxOpenService wxOpenService = wxThirdPartService.getWxOpenServiceByPlatFormId(platformId);
        WxOpenMpService wxMpService = wxOpenService.getWxOpenComponentService().getWxMpServiceByAppid(wxMessage.getToUser());



        SignRecommand signRecommand = signRecommendService.selectRandom();
        WxMpKefuMessage.WxArticle  wxArticle = new  WxMpKefuMessage.WxArticle();
        wxArticle.setTitle();
        new NewsBuilder().toUser(openid).addArticle()
        wxMpService.getKefuService().sendKefuMessage()
        pushService.addBookPushTask();


        return WxMpXmlOutMessage.TEXT().content(msg)
                .fromUser(wxMessage.getToUser()).toUser(wxMessage.getFromUser())
                .build();
    }

}
